package arbol; 
 


/**
 * Interfaz del iterador del ADT arbol
 */

public interface IteradorDeArbol<E> extends Cloneable
{   
    // operaciones de modificacion
    void insertaPrimerHijo(E elemento); 
    void insertaSiguienteHermano(E elemento);
    E eliminaHoja();
    E modificaElemento (E elementoNuevo);
    Arbol<E> cortaRama();
    Arbol<E> reemplazaRama(Arbol<E> nuevaRama);
    void anadeRama(Arbol<E> nuevaRama);
    
    // operaciones de consulta
    E contenido();
    boolean esHoja();
    boolean esRaiz();
    boolean esUltimoHijo();
    boolean esValido();

    // operaciones de recorrido
    void irARaiz();                     
    void irAPrimerHijo();
    void irASiguienteHermano();
    void irAPadre();
    
    //duplicar un iterador
    IteradorDeArbol<E> clone();

}
