package ej_arbol_expresion;

import ej_arbol.OperadorIncorrecto;

/**
 * Clase que representa un operador de una expresion
 */
public class Operador extends ElementoDeExpresion
{
    // atributo: el operador como un caracter
    private char operador;

    /**
     * Constructor
     */
    public Operador(char operador) throws OperadorIncorrecto
    {
        if (operador=='+' || operador=='-' ||
            operador=='*' ||    operador=='/' ||
            operador=='^')
            {
                this.operador=operador;   
            } else {
            throw new OperadorIncorrecto();
        }
    }

    /**
     * evalua el operador
     */
    public double evalua (Operando izq, Operando der)
    {
        switch (operador) {
        case '+': return izq.valor()+der.valor();
        case '-': return izq.valor()-der.valor();
        case '*': return izq.valor()*der.valor();
        case '/': return izq.valor()/der.valor();
        case '^': return Math.pow(izq.valor(),der.valor());
        default: return 0;

        }
    }
    
    /**
     * toString
     */
    @Override
    public String toString() {
        return Character.toString(operador);   
    }
    
    public char valor() {
        return operador;
    }
}
