package ej_arbol_expresion;
import recorridos_arbol.OpArboles;
import arbol.*;

/**
 * Programa que sirve para probar operaciones con un arbol 
 * que representa una expresion
 */
public class PruebaExpresion
{   
    public static void main (String[] args) {
        try {
            // crear los operadores y operandos
            Operador suma= new Operador('+');
            Operador resta=new Operador('-');
            Operador mult= new Operador('*');
            Operador div=  new Operador('/');
            Constante tres=new Constante(3);
            Constante cuatro=new Constante(4);
            Constante cinco=new Constante(5);
            Constante ocho=new Constante(8);
            
            // crear el arbol de la raiz a las hojas
            // expresion: 5+8*(3+4)-3*5
            Arbol<ElementoDeExpresion> arbol=
                new ArbolCE<ElementoDeExpresion>(suma);
            IteradorDeArbol<ElementoDeExpresion> iter=
                arbol.iterador();
            iter.insertaPrimerHijo(cinco);
            iter.irAPrimerHijo();
            iter.insertaSiguienteHermano(resta);
            iter.irASiguienteHermano();
            iter.insertaPrimerHijo(mult);
            iter.irAPrimerHijo();
            iter.insertaPrimerHijo(ocho);
            iter.irAPrimerHijo();
            iter.insertaSiguienteHermano(suma);
            iter.irASiguienteHermano();
            iter.insertaPrimerHijo(tres);
            iter.irAPrimerHijo();
            iter.insertaSiguienteHermano(cuatro);
            iter.irAPadre(); // suma
            iter.irAPadre(); // mult
            iter.insertaSiguienteHermano(mult);
            iter.irASiguienteHermano();
            iter.insertaPrimerHijo(tres);
            iter.irAPrimerHijo();
            iter.insertaSiguienteHermano(cinco);
            iter.irARaiz();
            
            // mostrar el arbol en preorden, postorden, e inorden
            System.out.println("Arbol en preorden:");
            OpArboles.muestraEnPreorden(iter);
            System.out.println();
            System.out.println();
            
            System.out.println("Arbol en postorden:");
            OpArboles.muestraEnPostorden(iter);
            System.out.println();
            System.out.println();
            
            System.out.println("Arbol en inorden:");
            OpArboles.muestraEnInorden(iter);
            System.out.println();
            System.out.println();
        } catch (Exception e) {
            System.out.println("Error: "+e);
        }
    }
}
