package ej_arbol_expresion;
import recorridos_arbol.OpArboles;
import arbol.*;

/**
 * Programa para probar una expresion
 */
public class PruebaExpresion2
{
    public static void main (String[] args) {
        try {
            // crear los operadores y operandos
            Operador resta=new Operador('-');
            Operador mult= new Operador('*');
            Operador div=  new Operador('/');
            Variable x=new Variable("x",1);
            Variable base=new Variable("base",1);
            Constante dos=new Constante(2);
            Constante tres=new Constante(3);
            
            // crear el arbol de la raiz a las hojas
            // expresion: 3*x-(base/2)
            
            Arbol<ElementoDeExpresion> arbol=
                new ArbolCE<ElementoDeExpresion>(resta);
            IteradorDeArbol<ElementoDeExpresion> iter=
                arbol.iterador();
            iter.insertaPrimerHijo(mult);
            System.out.println("Insertado primer hijo " + mult);
            iter.irAPrimerHijo();
            iter.insertaPrimerHijo(tres);
            System.out.println("Insertado primer hijo "+tres);
            iter.irAPrimerHijo();
            iter.insertaSiguienteHermano(x);
            System.out.println("Insertado siguiente hermano "+x);
            iter.irAPadre(); // mult
            iter.insertaSiguienteHermano(div);
            System.out.println("Insertado siguiente hermano "+div);
            iter.irASiguienteHermano();
            iter.insertaPrimerHijo(base);
            System.out.println("Insertado primer hijo "+base);
            iter.irAPrimerHijo();
            iter.insertaSiguienteHermano(dos);
            System.out.println("Insertado siguiente hermano "+dos);
            iter.irARaiz();
            
            //mostrar el arbol en preorden, postorden, e inorden
            System.out.println("Arbol en preorden:");
            OpArboles.muestraEnPreorden(iter);
            System.out.println();
            System.out.println();
            
            System.out.println("Arbol en postorden:");
            OpArboles.muestraEnPostorden(iter);
            System.out.println();
            System.out.println();
            
            System.out.println("Arbol en inorden:");
            OpArboles.muestraEnInorden(iter);
            System.out.println();
            System.out.println();
        } catch (Exception e) {
            System.out.println("Error: "+e);
        }
    }
}
