package recorridos_arbol;


import arbol.*;

/**
 * Clase con operaciones para manipular arboles
 */
public class OpArboles
{
	/**
	 * Mostrar el arbol en preorden
	 */
	public static <E> void muestraEnPreorden (IteradorDeArbol<E> iterador) {
		IteradorDeArbol<E> iter= iterador.clone();
		System.out.print(iter.contenido()+" ");
		iter.irAPrimerHijo();
		while (iter.esValido()) {
			muestraEnPreorden(iter);
			iter.irASiguienteHermano();
		}
	}

	/**
	 * Mostrar el arbol en postorden
	 */
	public static <E> void muestraEnPostorden (IteradorDeArbol<E> iterador) {
		IteradorDeArbol<E> iter= iterador.clone();
		E contenidoRaiz=iter.contenido();
		iter.irAPrimerHijo();
		while (iter.esValido()) {
			muestraEnPostorden(iter);
			iter.irASiguienteHermano();
		}
		System.out.print(contenidoRaiz+" ");
	}

	/**
	 * Mostrar el arbol en inorden
	 */
	public static <E> void muestraEnInorden (IteradorDeArbol<E> iterador) {
		IteradorDeArbol<E> iter= iterador.clone();
		E contenidoRaiz=iter.contenido();
		if (iter.esHoja()) {
			System.out.print(contenidoRaiz);
		} else {
			System.out.print("(");
			iter.irAPrimerHijo();
			muestraEnInorden(iter);
			System.out.print(contenidoRaiz);
			iter.irASiguienteHermano();
			while (iter.esValido()) {
				muestraEnInorden(iter);
				iter.irASiguienteHermano();
			}
			System.out.print(")");
		}
	}
}
